allow for exclude only configurations to rdiff-backup handler: Closes Trac#21
[matthijs/upstream/backupninja.git] / handlers / rdiff.in
1 # -*- mode: sh; sh-basic-offset: 3; indent-tabs-mode: nil; -*-
2 #
3 # rdiff-backup handler script for backupninja
4 # requires rdiff-backup
5 #
6
7 ### FUNCTIONS ###
8
9 function test_connection() {
10         # given a user and host,
11         # tests the connection.
12         # if user or host is missing, returns 0
13         # (ie, assume it's a local connection).
14         if [ $# -lt 2 ]; then
15                 debug "(local is assumed to be a good connection)"
16                 return 0
17         fi
18         local user=$1
19         local host=$2
20         debug "ssh $sshoptions -o PasswordAuthentication=no $host -l $user 'echo -n 1'"
21         local ret=`ssh $sshoptions -o PasswordAuthentication=no $host -l $user 'echo -n host is alive'`
22         if echo $ret | grep "host is alive"; then
23                 debug "Connected to $host as $user successfully"
24         else
25                 fatal "Can't connect to $host as $user."
26         fi
27 }
28
29 function get_version() {
30         # given no arguments, returns the local version.
31         # given a user and host, returns the remote version.
32         # if user or host is missing, returns the local version.
33         if [ "$#" -lt 2 ]; then
34                 debug "$RDIFFBACKUP -V"
35                 echo `$RDIFFBACKUP -V`
36         else
37                 local user=$1
38                 local host=$2
39                 debug "ssh $sshoptions $host -l $user '$RDIFFBACKUP -V'"
40                 echo `ssh $sshoptions $host -l $user "$RDIFFBACKUP -V | grep rdiff-backup"`
41         fi
42 }
43
44 function check_consistency() {
45         local section=$1
46         local type=$2
47         local user=$3
48         local host=$4
49         if [ "$type" == "local" ]; then
50                 if [ "$user" != "" ]; then
51                         warning "User should not be specified for local $section."
52                 fi
53                 if [ "$host" != "" ]; then
54                         warning "Host should not be specified for local $section."
55                 fi
56         fi
57         if [ "$type" == "remote" ]; then
58                 if [ "$user" == "" ]; then
59                         fatal "User must be specified for remote $section."
60                 fi
61                 if [ "host" == "" ]; then
62                         fatal "Host must be specifed for remote $section."
63                 fi
64         fi
65 }
66
67 function check_cstream() {
68         local cstream=$1
69         if [ ! -x $cstream ]; then
70                 fatal "Can't find your cstream binary (trying: $cstream). If you use bwlimit you must have cstream installed."
71         fi
72 }
73
74 ### GET CONFIG ###
75
76 getconf options
77 getconf testconnect yes
78 getconf nicelevel 0
79 getconf bwlimit
80
81 setsection source
82 getconf type; sourcetype=$type
83 getconf user; sourceuser=$user
84 getconf host; sourcehost=$host
85 check_consistency "source" "$type" "$user" "$host"
86 getconf label
87 getconf keep 60
88 getconf include
89 getconf vsnames all
90 getconf vsinclude
91 getconf exclude
92
93 setsection dest
94 getconf directory; destdir=$directory
95 # strip trailing /
96 destdir=${destdir%/}
97 getconf type; desttype=$type
98 getconf user; destuser=$user
99 getconf host; desthost=$host
100 getconf sshoptions
101 check_consistency "destination" "$type" "$user" "$host"
102
103 ### CHECK CONFIG ###
104
105 # If vservers are configured, check that the ones listed in $vsnames do exist.
106 local usevserver=no
107 if [ $vservers_are_available = yes ]; then
108    if [ "$vsnames" = all ]; then
109       vsnames="$found_vservers"
110    else
111       if ! vservers_exist "$vsnames" ; then
112             fatal "At least one of the vservers listed in vsnames ($vsnames) does not exist."
113       fi
114    fi
115    if [ -n "$vsinclude" ]; then
116       info "Using vservers '$vsnames'"
117       usevserver=yes
118    fi
119 else
120    [ -z "$vsinclude" ] || warning 'vservers support disabled in backupninja.conf, vsincludes configuration lines will be ignored'
121 fi
122
123 # check the connection at the source and destination
124 [ -n "$test" ] || test=0
125 if [ "$testconnect" = "yes" ] || [ "${test}" -eq 1 ]; then
126         test_connection $sourceuser $sourcehost
127         test_connection $destuser $desthost
128 fi
129
130 if [ $ignore_version != "yes" ]; then
131         # see that rdiff-backup has the same version at the source and destination
132         sourceversion=`get_version $sourceuser $sourcehost`
133         destversion=`get_version $destuser $desthost`
134         if [ "$sourceversion" != "$destversion" ]; then
135                 fatal "rdiff-backup does not have the same version at the source and at the destination."
136         fi
137 fi
138
139 # source specific checks
140 case $sourcetype in 
141         remote ) execstr_sourcepart="$sourceuser@$sourcehost::/" ;;
142         local  ) execstr_sourcepart="/" ;;
143         *      ) fatal "sourcetype '$sourcetype' is neither local nor remote" ;;
144 esac
145
146 # destination specific checks
147 [ "$destdir" != "" ] || fatal "Destination directory not set"
148 case $desttype in 
149         remote ) execstr_destpart="$destuser@$desthost::$destdir/$label" ;;
150         local  ) execstr_destpart="$destdir/$label" ;;
151         *      ) fatal "desttype '$desttype' is neither local nor remote" ;;
152 esac
153         
154 ### REMOVE OLD BACKUPS ###
155
156 if [ "$keep" != yes ]; then
157
158    if [ "`echo $keep | tr -d 0-9`" == "" ]; then
159         # add D if no other date unit is specified
160       keep="${keep}D"
161    fi
162
163    removestr="$RDIFFBACKUP $options --force --remove-older-than $keep "
164    if [ "$desttype" == "remote" ]; then
165       removestr="${removestr}${destuser}@${desthost}::"
166    fi
167    removestr="${removestr}${destdir}/${label}";
168
169    debug "$removestr"
170    if [ $test = 0 ]; then
171       output="`su -c "$removestr" 2>&1`"
172       if [ $? = 0 ]; then
173          debug $output
174          info "Removing backups older than $keep days succeeded."
175       else
176          warning $output
177          warning "Failed removing backups older than $keep."
178       fi
179    fi
180
181 fi
182
183 # Add cstream 
184
185 if [ ! -z $bwlimit ]; then
186         check_cstream $CSTREAM;
187         if [ "$desttype" = "remote" ]; then
188                 RDIFFBACKUP="$RDIFFBACKUP --remote-schema 'cstream -t $bwlimit | ssh %s \''rdiff-backup --server\'''"
189         elif [ "$sourcetype" = "remote" ]; then
190                 RDIFFBACKUP="$RDIFFBACKUP --remote-schema 'ssh %s \''rdiff-backup --server\'' | cstream -t $bwlimit'"
191         else
192                 fatal "You specified a bandwidth limit but neither your source nor destination types are remote."
193         fi
194 fi
195
196 ### EXECUTE ###
197
198 execstr="$RDIFFBACKUP $options --print-statistics "
199
200 set -o noglob
201
202 symlinks_warning="Maybe you have mixed symlinks and '*' in this statement, which is not supported."
203
204 # TODO: order the includes and excludes
205 # excludes
206 for i in $exclude; do
207    str="${i//__star__/*}"
208    execstr="${execstr}--exclude '$str' "
209 done
210 # includes 
211 for i in $include; do
212    [ "$i" != "/" ] || fatal "Sorry, you cannot use 'include = /'"
213    str="${i//__star__/*}"
214    execstr="${execstr}--include '$str' "
215 done
216
217 # vsinclude
218 if [ $usevserver = yes ]; then
219    for vserver in $vsnames; do
220       for vi in $vsinclude; do
221          str="${vi//__star__/*}"
222          str="$VROOTDIR/$vserver$str"
223          if [ -n "$str" ]; then
224             execstr="${execstr}--include '$str' "
225          else
226             warning "vsinclude statement '${vi//__star__/*}' will be ignored for VServer $vserver. $symlinks_warning"
227          fi
228       done
229    done
230 fi
231
232 set +o noglob
233
234 # exclude everything else
235 [ "$include" != "" -o "$vsinclude" != "" ] && execstr="${execstr}--exclude '/*' "
236                 
237 # include client-part and server-part
238 execstr="${execstr}$execstr_sourcepart $execstr_destpart"
239
240 debug "$execstr"
241 if [ $test = 0 ]; then
242         output=`nice -n $nicelevel su -c "$execstr" 2>&1`
243         if [ $? = 0 ]; then
244                 debug $output
245                 info "Successfully finished backing up source $label"
246         else
247                 warning $output
248                 warning "Failed backup up source $label"
249         fi
250 fi      
251
252 return 0